
import java.io.UnsupportedEncodingException;

class NetBiosName {
    static final String ENCODING = "ISO8859_1";
    static final int MESSENGER_SERVICE = 0x03;

    String name;
    int hexCode;

    NetBiosName(String name) {
        this(name, MESSENGER_SERVICE);
    }

    NetBiosName(String name, int hexCode) {
        if (name.length() > 15) {
            name = name.substring(0, 15);
        }
        this.name = name.toUpperCase();
        this.hexCode = hexCode;
    }

    int encode(byte[] dst, int dstIndex) throws UnsupportedEncodingException {
        dst[dstIndex] = 0x20;


        byte tmp[] = name.getBytes(ENCODING);
        int i;
        for (i = 0; i < tmp.length; i++) {
            dst[dstIndex + (2 * i + 1)] = (byte) (((tmp[i] & 0xF0) >> 4) + 0x41);
            dst[dstIndex + (2 * i + 2)] = (byte) ((tmp[i] & 0x0F) + 0x41);
        }
        for (; i < 15; i++) {
            dst[dstIndex + (2 * i + 1)] = (byte) 0x43;
            dst[dstIndex + (2 * i + 2)] = (byte) 0x41;
        }
        dst[dstIndex + 31] = (byte) (((hexCode & 0xF0) >> 4) + 0x41);
        dst[dstIndex + 32] = (byte) ((hexCode & 0x0F) + 0x41);
        dst[dstIndex + 33] = (byte) 0x00;

        return 34;
    }

}

